"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.getSigner = void 0;
const sdk_1 = require("@wormhole-foundation/sdk");
const evm_1 = __importDefault(require("@wormhole-foundation/sdk/platforms/evm"));
const solana_1 = __importDefault(require("@wormhole-foundation/sdk/platforms/solana"));
async function getSigner(chain) {
    // Read in from `.env`
    (await Promise.resolve().then(() => __importStar(require("dotenv")))).config();
    let signer;
    const platform = chain.platform.utils()._platform;
    switch (platform) {
        case "Solana":
            signer = await solana_1.default.getSigner(await chain.getRpc(), getEnv("OTHER_SOL_PRIVATE_KEY"), { priorityFeePercentile: 0.9, debug: true });
            break;
        case "Evm":
            signer = await evm_1.default.getSigner(await chain.getRpc(), getEnv("ETH_PRIVATE_KEY"));
            break;
        default:
            throw new Error("Unrecognized platform: " + platform);
    }
    return {
        chain,
        signer: signer,
        address: sdk_1.Wormhole.chainAddress(chain.chain, signer.address()),
    };
}
exports.getSigner = getSigner;
// Use .env.example as a template for your .env file and populate it with secrets
// for funded accounts on the relevant chain+network combos to run the example
function getEnv(key) {
    // If we're in the browser, return empty string
    if (typeof process === undefined)
        return "";
    // Otherwise, return the env var or error
    const val = process.env[key];
    if (!val)
        throw new Error(`Missing env var ${key}, did you forget to set values in '.env'?`);
    return val;
}
//# sourceMappingURL=helpers.js.map